-- Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.
--
-- Version 3 of the CMON schema. The base schema; modifications are made via
-- separate pieces of migration code.
--

UPDATE CMON_SCHEMA_VERSION SET VERSION=3;

CREATE TABLE cmon_activity (
    id bigint NOT NULL,
    service_name character varying(255),
    name character varying(255),
    begin_ts bigint,
    end_ts bigint,
    activity_type integer
);

CREATE TABLE cmon_activity_attribute (
    id bigint NOT NULL,
    activity_id bigint NOT NULL,
    metric_id integer NOT NULL,
    string_attr character varying(255) NOT NULL
);

CREATE TABLE cmon_activity_last_metric_val (
    id bigint NOT NULL,
    activity_id bigint NOT NULL,
    metric_id integer NOT NULL,
    ts bigint NOT NULL,
    value double precision NOT NULL
);

CREATE TABLE cmon_attempt (
    id bigint NOT NULL,
    name character varying(255) NOT NULL,
    begin_ts bigint,
    end_ts bigint,
    host character varying(255),
    attempt_type integer NOT NULL,
    activity_id bigint NOT NULL
);

CREATE TABLE cmon_attempt_last_metric_val (
    id bigint NOT NULL,
    attempt_id bigint NOT NULL,
    metric_id integer NOT NULL,
    ts bigint NOT NULL,
    value double precision NOT NULL
);

ALTER TABLE ONLY cmon_activity_attribute
    ADD CONSTRAINT cmon_activity_attribute_pkey PRIMARY KEY (id);


ALTER TABLE ONLY cmon_activity_last_metric_val
    ADD CONSTRAINT cmon_activity_last_metric_val_pkey PRIMARY KEY (id);

ALTER TABLE ONLY cmon_activity
    ADD CONSTRAINT cmon_activity_pkey PRIMARY KEY (id);

ALTER TABLE ONLY cmon_attempt_last_metric_val
    ADD CONSTRAINT cmon_attempt_last_metric_val_pkey PRIMARY KEY (id);

ALTER TABLE ONLY cmon_attempt
    ADD CONSTRAINT cmon_attempt_pkey PRIMARY KEY (id);

CREATE INDEX idx_activity_by_name ON cmon_activity USING btree (name);

CREATE INDEX idx_attempt_activity ON cmon_attempt USING btree (activity_id);

CREATE INDEX idx_attempt_by_name ON cmon_attempt USING btree (name);

CREATE INDEX idx_attempt_series_by_name ON cmon_activity USING btree (service_name);

ALTER TABLE ONLY cmon_attempt
    ADD CONSTRAINT fk_attempt_activity FOREIGN KEY (activity_id) REFERENCES cmon_activity(id)
    ON DELETE CASCADE;

ALTER TABLE ONLY cmon_attempt_last_metric_val
    ADD CONSTRAINT fk_attempt_lmv_attempt FOREIGN KEY (attempt_id) REFERENCES cmon_attempt(id)
    ON DELETE CASCADE;

ALTER TABLE ONLY cmon_activity_attribute
    ADD CONSTRAINT fk_activity_attr_activity FOREIGN KEY (activity_id) REFERENCES cmon_activity(id)
    ON DELETE CASCADE;
