// (c) Copyright 2012 Cloudera, Inc. All rights reserved.

/*global ko:false, define: false, $: false */
define([], function () {
	"use strict";

	return function (options) {

		var unselectCell = function ($parent) {
			$parent.find("input").attr("disabled", "disabled");
			$parent.find(".icon-ok").addClass("hidden");
		};

		var selectCell = function ($parent) {
			$parent.find("input").removeAttr("disabled");
			$parent.find(".icon-ok").removeClass("hidden");
		};

		var $containerSelector = $(options.containerSelector);
		$containerSelector.on('click', '.valueContainer', function (e) {
			var $tr, $tgt = $(e.target);
			if (!$tgt.is(".valueContainer")) {
				$tgt = $tgt.closest(".valueContainer");
			}
			$tr = $tgt.closest("tr");
			unselectCell($tr);
			selectCell($tgt);
		});

		$containerSelector.find(".allNewValue").click(function (e) {
			selectCell($containerSelector.find(".valueContainer .newValue"));
			unselectCell($containerSelector.find(".valueContainer .currentValue"));
			if (e) {
				e.preventDefault();
			}
		});

		$containerSelector.find(".allCurrentValue").click(function (e) {
			unselectCell($containerSelector.find(".valueContainer .newValue"));
			selectCell($containerSelector.find(".valueContainer .currentValue"));
			if (e) {
				e.preventDefault();
			}
		});
	};
});
