// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/chart/TimeControlledContent",
	"cloudera/common/I18nDataTable"
], function(TimeControlledContent, I18nDataTable) {

/**
 * JavaScript for the main Services Table.
 */
return function(options) {

/*
	var options = {
		showCommands: true|false,
		timestamp: timestamp,
		currentMode: currentMode,
		clusterId: clusterId,
		tableSelector: "#tableId",
		containerSelector: "#containerId",
		ajaxURL: "..."
	};
*/

	// Role Counts column and the Commands column are not sortable.
	var columnDefs = [{ "bSortable": false, "aTargets": [4,5,6] }];

	// Hide the commands column
	if (!options.showCommands) {
		columnDefs.push({ "bVisible": false, "aTargets": [6] });
	}

	var dataTableSettings = {
		"bSort": true,
		"bPaginate": false,
		"bFilter": false,
		"bInfo": false,
		"bAutoWidth": false,
		"aoColumnDefs": columnDefs
	};
	I18nDataTable.initialize(dataTableSettings);

	// Reactivate the data table.
	$(options.tableSelector).dataTable(dataTableSettings);

	var lastSortSettings;

	var beforeUpdate = function() {
		// This must match the id of the dataTable.
		var oTable = $(options.tableSelector).dataTable();
		var oSettings = oTable.fnSettings();
		lastSortSettings = oSettings.aaSorting;
		oTable.fnDestroy();
	};

	var afterUpdate = function() {
		var $table = $(options.tableSelector);
		$table.dataTable(dataTableSettings).fnSort(lastSortSettings);
	};

	var opts = {
		urlParams: {
			timestamp: options.timestamp,
			clusterId: options.clusterId,
			currentMode: options.currentMode
		},
		beforeUpdate: beforeUpdate,
		afterUpdate: afterUpdate,
		updateOnPageLoad: false,
		url: options.ajaxURL,
		containerSelector: options.containerSelector
	};
	var timeControlledContent = new TimeControlledContent(opts);
};

});
